/**************************************************************************
AdpKmean_3D.h - Shared header file for AdpKmean_3Dseg  

Author:  Paul Hughett

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

***************************************************************************/

#ifndef AdpKmean_3Dseg_H
#define AdpKmean_3Dseg_H

/* Functions defined in ApdKmean_3Dseg_Ebeta_test.c */
extern int adpkmean_3dseg( int echo_12, int NoRegion,
    const char *Name1, int ImgType1, float STD_1, float Weight_1,
    const char *Name2, int ImgType2, float STD_2, float Weight_2, 
    int N, int M, int First, int Last, int Total,
    float Res_XY, float Res_Z, int savemean );


/* Functions defined in ApdKmean_3Dinc.c */
extern void Create_LOTS (int N, int M, int SliceNo, 
   int Sp_X, int Sp_Y, int Sp_Z);
extern void Interp_Mn (int Pos_xi, int Pos_yj, int Pos_zk, float ****LocMn, 
   float *TotalMn, int Sp_XY, int Sp_Z, unsigned char ***SegImg, 
   int N, int M, int SliceNo, float *Means, int NoRegion);
extern void Total_Mn(float ***ImgP, unsigned char ***SegImgP, int N, int M, 
   int SliceNo, float *Means, int NoRegion);
extern void Update_Mn (float ****LocMn, float *TotalMn, int NoRegion, 
   int Sp_XY, int Sp_Z, unsigned char ***SegImg, float ***Image, 
   int N, int M, int SliceNo);
extern void Free_LOTS (void);
extern float Likelihood_1( float ***ImgP, unsigned char ***SegImgP,
    int N, int M, int SliceNo, int NoRegion, float InVar );
extern float Likelihood_2( float ***ImgP_1, float ***ImgP_2, 
   unsigned char ***SegImgP, int N, int M, int SliceNo, int NoRegion,
   float InVar_1GW, float InVar_2GW, float InVar_1C, float InVar_2C );
extern int Update_Seg1( float ***Image,  unsigned char ***SegIdx,
   int N, int M, int SliceNo, float ****AdpLocMn, float *TotalMn,
   int Sp_XY, int Sp_Z, int NoRegion, float Gibbs, float InVar, 
   int Gibbs3D, float *Likelihood );
extern int Update_Seg2( float ***Img_1, float ***Img_2,
   unsigned char ***SegIdx, int N, int M, int SliceNo, 
   float ****AdpLocMn_1, float ****AdpLocMn_2, float *TotalMn_1,
   float *TotalMn_2, int Sp_XY, int Sp_Z, int NoRegion, float Gibbs,
   float VarW_1GW, float VarW_1C, float VarW_2C, float VarW_2GW,
   int Gibbs3D, float *Likelihood, int CSF_Label );


#endif  /* ApdKmean_3Dseg_H */
