/****************************************************************************
Kmean_3Dseg.h - Publich header file for the Kmean_3Dseg suite

Author:  Paul Hughett

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

*****************************************************************************/

#include "definition.h"

/* Functions defined in Kmean_3Dinc.c */
extern void update_Kmean (Kmean_Info K_Mean, int NoRegion, float Delta);
extern void split_Kmean  (Kmean_Info K_Mean, int NoRegion, float Delta);

extern float minerr_1echo( float ImgValue, int Pos_xi,
		    int Pos_yj, int Pos_zk,
		    unsigned char ***SegIndex, int N, int M, int L,
		    Kmean_Info K_Mean, int NoRegion,
		    float GibbsPotential, float Weight,
		    int Gibbs3D );

extern float minerr_2echo( float ImgValue_1, float ImgValue_2,
		    int Pos_xi, int Pos_yj, int Pos_zk,
		    float Weight_1, float Weight_2,
		    unsigned char ***SegIndex, int N, int M, int L,
		    Kmean_Info Kmean_1, Kmean_Info Kmean_2, int NoRegion,
		    float GibbsPotential, int Gibbs3D );

/* Function defined in Kmean_3Dseg.c */
extern int kmean_3dseg( int echo_12, int NoRegion,
	     const char *Name1, int ImgType1, float Weight_1,
	     const char *Name2, int ImgType2, float Weight_2,
	     int N, int M, int First, int Last, int Total,
	     float Res_XY, float Res_Z,
	     float Perturb, float Epsilon, float GibbsPotential,
	     int savemean );

