/*--------------------------------------------------------------------------
conn_component.h -  Header file for conn_component.c                   

Author:  Michelle Yan

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
--------------------------------------------------------------------------*/

#ifndef CONN_COMPONENT
#define CONN_COMPONENT

#include <stdio.h>
#include <math.h>
#include <memory.h>

#include "list.h"

/*--------------------------------------------------------------------------*/
/* Structure for 3d pixel coordinates.                                      */
/*--------------------------------------------------------------------------*/

typedef struct _pixel3d_t 
{
   short   slice, row, col;
} CC_pixel3d_t;


/* Seed and size of a connected component or region */
typedef struct _region_seed_t 
{
   short   slice, row, col;    /* seed pixel coordinates. */
   int     regSize;            /* Number of pixels in the region */
} CC_reg_seed_t;



/* ------------------------------ */
/* Private function types         */
/* ------------------------------ */

typedef int (*compfunc)(void *, int, void *, int);
typedef int (*copyfunc)(void *, int, void *, void *);


/* -------------------------------------------------------------------------*/
/* public functions                                                         */
/* -------------------------------------------------------------------------*/
int  CC_flood_uchar( unsigned char ***, int, int, int, int, int, int,
		     unsigned char *, unsigned char * );
stack_t *CC_label_uchar( void ***, int, int, int );
int  CC_flood_ushort( unsigned short ***, int, int, int, int, int, int,
		      unsigned short *, unsigned short * );
stack_t *CC_label_ushort( void ***, int, int, int );


#endif
