/****************************************************************************
dist_inc.h - Declare functions defined in dist_inc.c 

Author:  Paul Hughett

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
*****************************************************************************/

#ifndef DIST_INC_H
#define DIST_INC_H

extern float dot_3d(struct Vector_3D *V1, struct Vector_3D *V2);
extern struct Vector_3D mk_Vector(float x, float y, float z,
   float u, float v, float min_d);
extern struct Vector_3D diff_p2p(struct Vector_3D *V1, struct Vector_3D *V2);
extern struct Vector_3D cross_3d(struct Vector_3D *V1, struct Vector_3D *V2);
extern float dist_p2p(struct Vector_3D *V1, struct Vector_3D *V2);
extern float dist_p(struct Vector_3D *V1);
extern float dist_p2s(struct Vector_3D *V1, struct Vector_3D **VS2,
   int *VS2_size);
extern float refine_dist_p2s(struct Vector_3D *V1, float Grid_inc);
extern void get_bs2dr(int IDER_u, int IDER_v, double u, double v,
   struct Vector_3D *V_DBS);
extern int get_dist_der(struct Vector_3D *V1, struct Vector_3D *V2,
   float *du1, float *dv1, float *inc_u, float *inc_v, int Quad_Apprx);
extern float dist_p2bs(struct Vector_3D *V1);
extern struct Vector_3D rotate_alpha_z( struct Vector_3D *V1,
   double cos_alpha_z, double sin_alpha_z);
extern struct Vector_3D rotate_alpha_y( struct Vector_3D *V1,
   double cos_alpha_y, double sin_alpha_y);
extern struct Vector_3D rotate_alpha_x( struct Vector_3D *V1,
   double cos_alpha_x, double sin_alpha_x);
extern struct Vector_3D rotate_3D(struct Vector_3D *V1, double **RotateMatrix);
extern struct Vector_3D transform_3D(struct Vector_3D *V1, float u, float v,
   float min_d, Transform_Info trans_parameter);
extern void mk_trans_info (Transform_Info *transform);
extern void get_T_der_p2bs(struct Vector_3D *V0, struct Vector_3D *V1,
   Transform_Info transform, struct Vector_3D *D_translate,
   struct Vector_3D *D_rotate);
extern int IN_S1(float x, float y, float z, float low_x, float up_x,
   float low_y, float up_y, float low_z, float up_z);
extern void transform_VS(struct Vector_3D **VS, struct Vector_3D **VS_T,
   int *VS_size, Transform_Info transform);
extern float get_distance(struct Vector_3D **VS1, int *VS1_size,
   struct Vector_3D **VS2, int *VS2_size, float low_xi, float up_xi,
   float low_yj, float up_yj, float lo_zk, float up_zk, int *In_PixNum);
extern void reduce_VS(struct Vector_3D **VS, struct Vector_3D ***RVS,
   int *VS_size, int **RVS_size, int rate_XY, int rate_Z);

#endif /* DIST_INC_H */
