/****************************************************************************
image_inc.h - Prototypes for functions defined in image_inc.c

Author:  Paul Hughett

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.


This public header file contains prototypes for various image processing
functions defined in image_inc.c and used in the bblimage package.

*****************************************************************************/

#ifndef IMAGE_INC_H
#define IMAGE_INC_H


extern void smoothing(float **InImgP, float **OutImgP, int N, int M, 
    int FilterType);
extern float Scale2Char (float **InImgP, float **OutImgP, int N, int M);
extern float Scale2Char3D (float ***InImg, unsigned char ***OutChar,
     int N, int M, int L, int SmoothOpt);
extern int Threshold2Bin(float **InImgP, unsigned char **OutChar, 
    float TLow, float THigh, int N, int M);
extern int histogram3D(unsigned char ***InChar, float *OutHistoP, 
    int N, int M, int L);
extern void Kmeans_threshold(float *histogram, int ngray, int nclass,
    int *thresh);
extern int select_threshold(float *Ptr_Histo1D);
extern int refine_threshold(float Threshold, unsigned char ***MaskIn, 
    unsigned char ***CharIn, int N, int M, int L);
extern void MeanStd(float *Histo, float OptT, float *Mean_O, float *STD_O);
extern void BinaryImg3D(unsigned char ***CharIn, unsigned char ***MaskOut, 
    int N, int M, int L, char *UpperT_YN);
extern void Kmeans_binarize(unsigned char ***CharIn, unsigned char ***MaskOut,
    int N, int M, int L, int nclass, int nlower, int nupper)  ;
extern float histo_mean(float *HistoP, float opt_threshold);


#endif  /* IMAGE_INC_H */
